// Copyright (c) 1999-2010  Pavel Rychly

#ifndef FINLIB_FSTREAM_HH
#define FINLIB_FSTREAM_HH

#include <finlib/config.hh>
#include <map>

typedef long long int Position; // must be signed
typedef Position NumOfPos;
typedef std::map<int,Position> Labels;
#define STR2NUMPOS(s) atoll(s)


#if defined __WORDSIZE && defined INT64_MAX && __WORDSIZE == 64
const Position maxPosition = INT64_MAX;
#else
const Position maxPosition = 2147483647;
#endif


class FastStream {
protected:
    FastStream() {}
public:
    virtual ~FastStream() {}
    virtual void add_labels (Labels &lab) {};
    virtual Position peek() = 0;
    virtual Position next() = 0;
    virtual Position find (Position pos) = 0;
    virtual NumOfPos rest_min() = 0;
    virtual NumOfPos rest_max() = 0;
    virtual Position final() = 0;
};

#endif

// vim: ts=4 sw=4 sta et sts=4 si cindent tw=80:
