// Copyright (c) 2001-2008  Pavel Rychly

#ifndef FINLIB_WRITELEX_HH
#define FINLIB_WRITELEX_HH

#include <finlib/lexicon.hh>
#include <finlib/fromtof.hh>

#if defined __GNUC__ && __GNUC__ >= 3
#include <ext/hash_map>
#else
#include <hash_map>
#endif

#if defined __GNUC__ && (__GNUC__ == 3 && __GNUC_MINOR__ >= 1 || __GNUC__ >= 4)
#define HASH_NAMESPACE __gnu_cxx::
#else
#define HASH_NAMESPACE std::
#endif


class write_lexicon
{
    struct string_hash {
	HASH_NAMESPACE hash<const char*> h;
	string_hash() {}
	size_t operator()(const std::string &s) const {
	    return h (s.c_str());
	}
    };
    struct int_1 {
	int i;
	int_1(): i(-1) {}
    };

    const std::string filename;
    unsigned int maxitems;
    HASH_NAMESPACE hash_map<std::string,int_1,string_hash> cache;
    HASH_NAMESPACE hash_map<std::string,int,string_hash> added;
    FILE *lexf;
    ToFile<int> *lidxf;
    ToFile<int> *lsrtf;
    unsigned int lexftell;
    int nextid;
    map_lexicon *lex;
    int new_item (const char *str);
    void flush_hash ();
public:
    write_lexicon (const std::string &filename, int maxitems);
    ~write_lexicon ();
    int str2id(const char *str);
    int size() {return nextid;}
};

int make_lex_srt_file (const std::string &filename);

#endif
